fuzzydl

## Class Concept

- java.lang.Object
- - fuzzydl.Concept

- Direct Known Subclasses:
    ChoquetIntegral, FuzzyConcreteConcept, ModifiedConcept, NegatedNominal, OwaConcept, SugenoIntegral, WeightedMaxConcept, WeightedMinConcept, WeightedSumConcept, WeightedSumZeroConcept

      public class Concept
      extends java.lang.Object

  Fuzzy concept.
  Author:
    Fernando Bobillo

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ALL` Universal restriction.
    `static int` | `AND` Conjunction.
    `static int` | `AT_LEAST_VALUE` At least datatype restriction.
    `static int` | `AT_MOST_VALUE` At most datatype restriction.
    `static int` | `ATOMIC` Atomic concept.
    `static int` | `BOTTOM` Bottom concept.
    `static int` | `CHOQUET_INTEGRAL` Choquet integral.
    `static int` | `COMPLEMENT` Complement.
    `static Concept` | `CONCEPT_BOTTOM` Gets a bottom concept.
    `static Concept` | `CONCEPT_TOP` Gets a top concept.
    `static int` | `CONCRETE` Concrete concept.
    `static int` | `CONCRETE_COMPLEMENT` Negated concrete concept.
    `static java.lang.String` | `DEFAULT_NAME` Default prefix for new individual names.
    `static int` | `EXACT_VALUE` Exact datatype restriction.
    `static int` | `EXT_NEG_THRESHOLD` Extended negative threshold.
    `static int` | `EXT_POS_THRESHOLD` Extended positive threshold.
    `static int` | `FUZZY_NUMBER` Fuzzy number.
    `static int` | `FUZZY_NUMBER_COMPLEMENT` Negated fuzzy number.
    `static int` | `G_AND` Goedel conjunction.
    `static int` | `G_IMPLIES` Goedel implication.
    `static int` | `G_OR` Goedel disjunction.
    `static int` | `HAS_VALUE` Has value restriction concept.
    `static int` | `L_AND` Lukasiewicz conjunction.
    `static int` | `L_OR` Lukasiewicz disjunction.
    `static int` | `LOOSE_LOWER_APPROX` Loose lower fuzzy rough concept.
    `static int` | `LOOSE_UPPER_APPROX` Loose upper fuzzy rough concept.
    `static int` | `LOWER_APPROX` Lower fuzzy rough concept.
    `static int` | `MODIFIED` Modified concept.
    `static int` | `MODIFIED_COMPLEMENT` Negated modified concept.
    `static int` | `NEG_THRESHOLD` Negative threshold.
    `static int` | `NOT_AT_LEAST_VALUE` Negated at least datatype restriction.
    `static int` | `NOT_AT_MOST_VALUE` Negated at most datatype restriction.
    `static int` | `NOT_CHOQUET_INTEGRAL` Negated Choquet integral.
    `static int` | `NOT_EXACT_VALUE` Negated exact datatype restriction.
    `static int` | `NOT_EXT_NEG_THRESHOLD` Extended negated negative threshold.
    `static int` | `NOT_EXT_POS_THRESHOLD` Extended negated positive threshold.
    `static int` | `NOT_G_IMPLIES` Negated Goedel implication.
    `static int` | `NOT_HAS_VALUE` Negated has value restriction concept.
    `static int` | `NOT_NEG_THRESHOLD` Negated negative threshold.
    `static int` | `NOT_OWA` Negated OWA concept.
    `static int` | `NOT_POS_THRESHOLD` Negated positive threshold.
    `static int` | `NOT_QUANTIFIED_OWA` Negated quantifier-guided OWA concept.
    `static int` | `NOT_QUASI_SUGENO_INTEGRAL` Negated quasi-Sugeno integral.
    `static int` | `NOT_SELF` Negated self reflexivity concept.
    `static int` | `NOT_SUGENO_INTEGRAL` Negated Sugeno integral.
    `static int` | `NOT_W_MAX` Negated weighted maximum.
    `static int` | `NOT_W_MIN` Negated weighted minimum.
    `static int` | `NOT_W_SUM` Negated weighted sum.
    `static int` | `NOT_W_SUM_ZERO` Negated weighted sum.
    `static int` | `NOT_WEIGHTED` Negated weighted concept.
    `static int` | `NOT_Z_IMPLIES` Negated Zadeh'set inclusion implication.
    `static int` | `OR` Disjunction.
    `static int` | `OWA` OWA concept.
    `static int` | `POS_THRESHOLD` Positive threshold.
    `static int` | `QUANTIFIED_OWA` Quantifier-guided OWA concept.
    `static int` | `QUASI_SUGENO_INTEGRAL` Quasi-Sugeno integral.
    `static int` | `SELF` Self reflexivity concept.
    `static int` | `SOME` Existential restriction.
    `static int` | `SUGENO_INTEGRAL` Sugeno integral.
    `static int` | `TIGHT_LOWER_APPROX` Tight lower fuzzy rough concept.
    `static int` | `TIGHT_UPPER_APPROX` Tight upper fuzzy rough concept.
    `static int` | `TOP` Top concept.
    `static int` | `UPPER_APPROX` Upper fuzzy rough concept.
    `static int` | `W_MAX` Weighted maximum.
    `static int` | `W_MIN` Weighted minimum.
    `static int` | `W_SUM` Weighted sum.
    `static int` | `W_SUM_ZERO` Weighted sum.
    `static int` | `WEIGHTED` Weighted concept.
    `static int` | `Z_IMPLIES` Zadeh'set inclusion implication, only used for min-subs queries.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Concept(java.lang.String name)` Atomic concept constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Concept` | `all(java.lang.String role, Concept c)` Gets a new universal restriction concept.
    `static Concept` | `and(java.util.ArrayList<Concept> v)` Gets a new n-ary conjunction concept.
    `static Concept` | `and(Concept c1, Concept c2)` Gets a new binary conjunction concept.
    `static Concept` | `atLeastValue(java.lang.String role, java.lang.Object o)` Gets a new at-least datatype restriction concept.
    `static Concept` | `atMostValue(java.lang.String role, java.lang.Object o)` Gets a new at-most datatype restriction concept.
    `static Concept` | `complement(Concept c)` Gets the complement of the concept.
    `static int` | `containsNegatedSubconcept(java.util.ArrayList<Concept> v, Concept cj)`
    `static boolean` | `containsSubconcept(java.util.ArrayList<Concept> v, Concept cj)`
    `boolean` | `equals(Concept c)`
    `static Concept` | `exactValue(java.lang.String role, java.lang.Object o)` Gets a new exact datatype restriction concept.
    `static Concept` | `extendedNegThreshold(Variable w, Concept c)` Gets a new extended negative threshold concept.
    `static Concept` | `extendedPosThreshold(Variable w, Concept c)` Gets a new extended positive threshold concept.
    `static Concept` | `gAnd(java.util.ArrayList<Concept> v)` Gets a new n-ary conjunction concept under Goedel semantics.
    `static Concept` | `gAnd(Concept c1, Concept c2)` Gets a new binary conjunction concept under Goedel semantics.
    `java.util.HashSet<java.lang.String>` | `getAtomicConceptNames()`
    `java.util.HashSet<Concept>` | `getAtomicConcepts()`
    `java.lang.String` | `getRole()` Gets the role attribute.
    `int` | `getType()` Gets the type of the concept.
    `java.lang.Object` | `getValue()` Gets the value attribute.
    `double` | `getWeight()` Gets the weight attribute.
    `Variable` | `getWeightVar()` Gets the weight variable;
    `static Concept` | `gImplies(Concept c1, Concept c2)` Gets a new implication concept under Goedel semantics.
    `static Concept` | `gOr(java.util.ArrayList<Concept> v)` Gets a new n-ary disjunction concept under Goedel semantics.
    `static Concept` | `gOr(Concept c1, Concept c2)` Gets a new binary disjunction concept under Goedel semantics.
    `boolean` | `hasNominals()`
    `static Concept` | `hasValue(java.lang.String role, Individual i)` Gets a new has value restriction concept.
    `static Concept` | `hasValue(java.lang.String role, java.lang.String i)` Gets a new has value restriction concept.
    `boolean` | `isAtomic()` Checks if the concept is atomic.
    `boolean` | `isComplementedAtomic()` Checks if the concept is complemented atomic.
    `boolean` | `isConcrete()` Checks if the concept is concrete (types CONCRETE, CONCRETE_COMPLEMENT, FUZZY_NUMBER or FUZZY_NUMBER_COMPLEMENT)
    `static Concept` | `kdImplies(Concept c1, Concept c2)` Gets a new implication concept under Kleene-Dienes semantics.
    `static Concept` | `lAnd(java.util.ArrayList<Concept> v)` Gets a new n-ary conjunction concept under Lukasiewicz semantics.
    `static Concept` | `lAnd(Concept c1, Concept c2)` Gets a new binary conjunction concept under Lukasiewicz semantics.
    `static Concept` | `lImplies(Concept c1, Concept c2)` Gets a new implication concept under Lukasiewicz semantics.
    `static Concept` | `looseLowerApprox(java.lang.String role, Concept c)` Gets a new loose lower fuzzy rough concept.
    `static Concept` | `looseUpperApprox(java.lang.String role, Concept c)` Gets a new loose upper fuzzy rough concept.
    `static Concept` | `lOr(java.util.ArrayList<Concept> v)` Gets a new n-ary disjunction concept under Lukasiewicz semantics.
    `static Concept` | `lOr(Concept c1, Concept c2)` Gets a new binary disjunction concept under Lukasiewicz semantics.
    `static Concept` | `lowerApprox(java.lang.String role, Concept c)` Gets a new lower fuzzy rough concept.
    `static Concept` | `nAry(int type, java.util.ArrayList<Concept> v)` Gets a new n-ary concept.
    `static Concept` | `negThreshold(double w, Concept c)` Gets a new negative threshold concept.
    `static Concept` | `newAtomicConcept()` Gets a new atomic concept.
    `static Concept` | `notHasValue(java.lang.String role, java.lang.String i)` Gets a new negated has value restriction concept.
    `static Concept` | `or(java.util.ArrayList<Concept> v)` Gets a new n-ary disjunction concept.
    `static Concept` | `or(Concept c1, Concept c2)` Gets a new binary disjunction concept.
    `static Concept` | `posThreshold(double w, Concept c)` Gets a new positive threshold concept.
    `static void` | `removeElement(java.util.ArrayList<Concept> v, int i)`
    `Concept` | `replace(Concept a, Concept c)` Gets a new concept by replacing an atomic concept a with a complex concept c.
    `static Concept` | `self(java.lang.String role)` Gets a new local reflexivity concept.
    `void` | `setName(java.lang.String newName)` Sets the name of the concept.
    `void` | `setType(int type)` Sets the type of the concept.
    `void` | `setValue(java.lang.Object newValue)` Sets the value attribute.
    `static Concept` | `some(java.lang.String role, Concept c)` Gets a new existential restriction concept.
    `static Concept` | `tightLowerApprox(java.lang.String role, Concept c)` Gets a new tight lower fuzzy rough concept.
    `static Concept` | `tightUpperApprox(java.lang.String role, Concept c)` Gets a new tight upper fuzzy rough concept.
    `java.lang.String` | `toString()` Gets a printable name of the concept.
    `static Concept` | `upperApprox(java.lang.String role, Concept c)` Gets a new upper fuzzy rough concept.
    `static Concept` | `weightedConcept(double w, Concept c)` Gets a new weighted concept.
    `static Concept` | `zImplies(Concept c1, Concept c2)` Gets a new implication concept under Zadeh semantics.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_NAME

          public static final java.lang.String DEFAULT_NAME

      Default prefix for new individual names.
      See Also:
        Constant Field Values

    - #### AND

          public static final int AND

      Conjunction.
      See Also:
        Constant Field Values

    - #### G_AND

          public static final int G_AND

      Goedel conjunction.
      See Also:
        Constant Field Values

    - #### L_AND

          public static final int L_AND

      Lukasiewicz conjunction.
      See Also:
        Constant Field Values

    - #### OR

          public static final int OR

      Disjunction.
      See Also:
        Constant Field Values

    - #### G_OR

          public static final int G_OR

      Goedel disjunction.
      See Also:
        Constant Field Values

    - #### L_OR

          public static final int L_OR

      Lukasiewicz disjunction.
      See Also:
        Constant Field Values

    - #### SOME

          public static final int SOME

      Existential restriction.
      See Also:
        Constant Field Values

    - #### ALL

          public static final int ALL

      Universal restriction.
      See Also:
        Constant Field Values

    - #### UPPER_APPROX

          public static final int UPPER_APPROX

      Upper fuzzy rough concept.
      See Also:
        Constant Field Values

    - #### LOWER_APPROX

          public static final int LOWER_APPROX

      Lower fuzzy rough concept.
      See Also:
        Constant Field Values

    - #### FUZZY_NUMBER_COMPLEMENT

          public static final int FUZZY_NUMBER_COMPLEMENT

      Negated fuzzy number.
      See Also:
        Constant Field Values

    - #### TIGHT_UPPER_APPROX

          public static final int TIGHT_UPPER_APPROX

      Tight upper fuzzy rough concept.
      See Also:
        Constant Field Values

    - #### TIGHT_LOWER_APPROX

          public static final int TIGHT_LOWER_APPROX

      Tight lower fuzzy rough concept.
      See Also:
        Constant Field Values

    - #### LOOSE_UPPER_APPROX

          public static final int LOOSE_UPPER_APPROX

      Loose upper fuzzy rough concept.
      See Also:
        Constant Field Values

    - #### LOOSE_LOWER_APPROX

          public static final int LOOSE_LOWER_APPROX

      Loose lower fuzzy rough concept.
      See Also:
        Constant Field Values

    - #### G_IMPLIES

          public static final int G_IMPLIES

      Goedel implication.
      See Also:
        Constant Field Values

    - #### NOT_G_IMPLIES

          public static final int NOT_G_IMPLIES

      Negated Goedel implication.
      See Also:
        Constant Field Values

    - #### ATOMIC

          public static final int ATOMIC

      Atomic concept.
      See Also:
        Constant Field Values

    - #### COMPLEMENT

          public static final int COMPLEMENT

      Complement.
      See Also:
        Constant Field Values

    - #### TOP

          public static final int TOP

      Top concept.
      See Also:
        Constant Field Values

    - #### BOTTOM

          public static final int BOTTOM

      Bottom concept.
      See Also:
        Constant Field Values

    - #### AT_MOST_VALUE

          public static final int AT_MOST_VALUE

      At most datatype restriction.
      See Also:
        Constant Field Values

    - #### AT_LEAST_VALUE

          public static final int AT_LEAST_VALUE

      At least datatype restriction.
      See Also:
        Constant Field Values

    - #### EXACT_VALUE

          public static final int EXACT_VALUE

      Exact datatype restriction.
      See Also:
        Constant Field Values

    - #### NOT_AT_MOST_VALUE

          public static final int NOT_AT_MOST_VALUE

      Negated at most datatype restriction.
      See Also:
        Constant Field Values

    - #### NOT_AT_LEAST_VALUE

          public static final int NOT_AT_LEAST_VALUE

      Negated at least datatype restriction.
      See Also:
        Constant Field Values

    - #### NOT_EXACT_VALUE

          public static final int NOT_EXACT_VALUE

      Negated exact datatype restriction.
      See Also:
        Constant Field Values

    - #### WEIGHTED

          public static final int WEIGHTED

      Weighted concept.
      See Also:
        Constant Field Values

    - #### NOT_WEIGHTED

          public static final int NOT_WEIGHTED

      Negated weighted concept.
      See Also:
        Constant Field Values

    - #### W_SUM

          public static final int W_SUM

      Weighted sum.
      See Also:
        Constant Field Values

    - #### NOT_W_SUM

          public static final int NOT_W_SUM

      Negated weighted sum.
      See Also:
        Constant Field Values

    - #### POS_THRESHOLD

          public static final int POS_THRESHOLD

      Positive threshold.
      See Also:
        Constant Field Values

    - #### NOT_POS_THRESHOLD

          public static final int NOT_POS_THRESHOLD

      Negated positive threshold.
      See Also:
        Constant Field Values

    - #### NEG_THRESHOLD

          public static final int NEG_THRESHOLD

      Negative threshold.
      See Also:
        Constant Field Values

    - #### NOT_NEG_THRESHOLD

          public static final int NOT_NEG_THRESHOLD

      Negated negative threshold.
      See Also:
        Constant Field Values

    - #### EXT_POS_THRESHOLD

          public static final int EXT_POS_THRESHOLD

      Extended positive threshold.
      See Also:
        Constant Field Values

    - #### NOT_EXT_POS_THRESHOLD

          public static final int NOT_EXT_POS_THRESHOLD

      Extended negated positive threshold.
      See Also:
        Constant Field Values

    - #### EXT_NEG_THRESHOLD

          public static final int EXT_NEG_THRESHOLD

      Extended negative threshold.
      See Also:
        Constant Field Values

    - #### NOT_EXT_NEG_THRESHOLD

          public static final int NOT_EXT_NEG_THRESHOLD

      Extended negated negative threshold.
      See Also:
        Constant Field Values

    - #### CONCRETE

          public static final int CONCRETE

      Concrete concept.
      See Also:
        Constant Field Values

    - #### CONCRETE_COMPLEMENT

          public static final int CONCRETE_COMPLEMENT

      Negated concrete concept.
      See Also:
        Constant Field Values

    - #### MODIFIED

          public static final int MODIFIED

      Modified concept.
      See Also:
        Constant Field Values

    - #### MODIFIED_COMPLEMENT

          public static final int MODIFIED_COMPLEMENT

      Negated modified concept.
      See Also:
        Constant Field Values

    - #### SELF

          public static final int SELF

      Self reflexivity concept.
      See Also:
        Constant Field Values

    - #### FUZZY_NUMBER

          public static final int FUZZY_NUMBER

      Fuzzy number.
      See Also:
        Constant Field Values

    - #### OWA

          public static final int OWA

      OWA concept.
      See Also:
        Constant Field Values

    - #### QUANTIFIED_OWA

          public static final int QUANTIFIED_OWA

      Quantifier-guided OWA concept.
      See Also:
        Constant Field Values

    - #### NOT_OWA

          public static final int NOT_OWA

      Negated OWA concept.
      See Also:
        Constant Field Values

    - #### NOT_QUANTIFIED_OWA

          public static final int NOT_QUANTIFIED_OWA

      Negated quantifier-guided OWA concept.
      See Also:
        Constant Field Values

    - #### CHOQUET_INTEGRAL

          public static final int CHOQUET_INTEGRAL

      Choquet integral.
      See Also:
        Constant Field Values

    - #### SUGENO_INTEGRAL

          public static final int SUGENO_INTEGRAL

      Sugeno integral.
      See Also:
        Constant Field Values

    - #### QUASI_SUGENO_INTEGRAL

          public static final int QUASI_SUGENO_INTEGRAL

      Quasi-Sugeno integral.
      See Also:
        Constant Field Values

    - #### NOT_CHOQUET_INTEGRAL

          public static final int NOT_CHOQUET_INTEGRAL

      Negated Choquet integral.
      See Also:
        Constant Field Values

    - #### NOT_SUGENO_INTEGRAL

          public static final int NOT_SUGENO_INTEGRAL

      Negated Sugeno integral.
      See Also:
        Constant Field Values

    - #### NOT_QUASI_SUGENO_INTEGRAL

          public static final int NOT_QUASI_SUGENO_INTEGRAL

      Negated quasi-Sugeno integral.
      See Also:
        Constant Field Values

    - #### W_MAX

          public static final int W_MAX

      Weighted maximum.
      See Also:
        Constant Field Values

    - #### NOT_W_MAX

          public static final int NOT_W_MAX

      Negated weighted maximum.
      See Also:
        Constant Field Values

    - #### W_MIN

          public static final int W_MIN

      Weighted minimum.
      See Also:
        Constant Field Values

    - #### NOT_W_MIN

          public static final int NOT_W_MIN

      Negated weighted minimum.
      See Also:
        Constant Field Values

    - #### W_SUM_ZERO

          public static final int W_SUM_ZERO

      Weighted sum.
      See Also:
        Constant Field Values

    - #### NOT_W_SUM_ZERO

          public static final int NOT_W_SUM_ZERO

      Negated weighted sum.
      See Also:
        Constant Field Values

    - #### NOT_SELF

          public static final int NOT_SELF

      Negated self reflexivity concept.
      See Also:
        Constant Field Values

    - #### HAS_VALUE

          public static final int HAS_VALUE

      Has value restriction concept.
      See Also:
        Constant Field Values

    - #### NOT_HAS_VALUE

          public static final int NOT_HAS_VALUE

      Negated has value restriction concept.
      See Also:
        Constant Field Values

    - #### Z_IMPLIES

          public static final int Z_IMPLIES

      Zadeh'set inclusion implication, only used for min-subs queries.
      See Also:
        Constant Field Values

    - #### NOT_Z_IMPLIES

          public static final int NOT_Z_IMPLIES

      Negated Zadeh'set inclusion implication.
      See Also:
        Constant Field Values

    - #### CONCEPT_TOP

          public static final Concept CONCEPT_TOP

      Gets a top concept.

    - #### CONCEPT_BOTTOM

          public static final Concept CONCEPT_BOTTOM

      Gets a bottom concept.

  - ### Constructor Detail

    - #### Concept

          public Concept(java.lang.String name)

      Atomic concept constructor.
      Parameters:
        `name` - Name of the atomic concept

  - ### Method Detail

    - #### newAtomicConcept

          public static Concept newAtomicConcept()

      Gets a new atomic concept.
      Returns:
        A new atomic concept.

    - #### and

          public static Concept and(Concept c1,
                                    Concept c2)

      Gets a new binary conjunction concept.
      Parameters:
        `c1` - A concept.
        `c2` - Another concept.
      Returns:
        A new binary conjunction concept.

    - #### and

          public static Concept and(java.util.ArrayList<Concept> v)

      Gets a new n-ary conjunction concept.
      Parameters:
        `v` - List of concepts.
      Returns:
        A new n-ary conjunction concept.

    - #### gAnd

          public static Concept gAnd(Concept c1,
                                     Concept c2)

      Gets a new binary conjunction concept under Goedel semantics.
      Parameters:
        `c1` - A concept.
        `c2` - Another concept.
      Returns:
        A new binary conjunction concept under Goedel semantics.

    - #### gAnd

          public static Concept gAnd(java.util.ArrayList<Concept> v)

      Gets a new n-ary conjunction concept under Goedel semantics.
      Parameters:
        `v` - List of concepts.
      Returns:
        A new n-ary conjunction concept under Goedel semantics.

    - #### lAnd

          public static Concept lAnd(Concept c1,
                                     Concept c2)

      Gets a new binary conjunction concept under Lukasiewicz semantics.
      Parameters:
        `c1` - A concept.
        `c2` - Another concept.
      Returns:
        A new binary conjunction concept under Lukasiewicz semantics.

    - #### lAnd

          public static Concept lAnd(java.util.ArrayList<Concept> v)

      Gets a new n-ary conjunction concept under Lukasiewicz semantics.
      Parameters:
        `v` - List of concepts.
      Returns:
        A new n-ary conjunction concept under Lukasiewicz semantics.

    - #### or

          public static Concept or(Concept c1,
                                   Concept c2)

      Gets a new binary disjunction concept.
      Parameters:
        `c1` - A concept.
        `c2` - Another concept.
      Returns:
        A new binary disjunction concept.

    - #### or

          public static Concept or(java.util.ArrayList<Concept> v)

      Gets a new n-ary disjunction concept.
      Parameters:
        `v` - List of concepts.
      Returns:
        A new n-ary disjunction concept.

    - #### gOr

          public static Concept gOr(Concept c1,
                                    Concept c2)

      Gets a new binary disjunction concept under Goedel semantics.
      Parameters:
        `c1` - A concept.
        `c2` - Another concept.
      Returns:
        A new binary disjunction concept under Goedel semantics.

    - #### gOr

          public static Concept gOr(java.util.ArrayList<Concept> v)

      Gets a new n-ary disjunction concept under Goedel semantics.
      Parameters:
        `v` - List of concepts.
      Returns:
        A new n-ary disjunction concept under Goedel semantics.

    - #### lOr

          public static Concept lOr(Concept c1,
                                    Concept c2)

      Gets a new binary disjunction concept under Lukasiewicz semantics.
      Parameters:
        `c1` - A concept.
        `c2` - Another concept.
      Returns:
        A new binary disjunction concept under Lukasiewicz semantics.

    - #### lOr

          public static Concept lOr(java.util.ArrayList<Concept> v)

      Gets a new n-ary disjunction concept under Lukasiewicz semantics.
      Parameters:
        `v` - List of concepts.
      Returns:
        A new n-ary disjunction concept under Lukasiewicz semantics.

    - #### nAry

          public static Concept nAry(int type,
                                     java.util.ArrayList<Concept> v)

      Gets a new n-ary concept.
      Parameters:
        `type` - Type of the concept (conjunctions or disjuntions).
        `v` - List of concepts.
      Returns:
        A new n-ary concept.

    - #### lImplies

          public static Concept lImplies(Concept c1,
                                         Concept c2)

      Gets a new implication concept under Lukasiewicz semantics.
      Parameters:
        `c1` - Implicator concept.
        `c2` - Implicated concept.
      Returns:
        A new implication concept under Lukasiewicz semantics.

    - #### kdImplies

          public static Concept kdImplies(Concept c1,
                                          Concept c2)

      Gets a new implication concept under Kleene-Dienes semantics.
      Parameters:
        `c1` - Implicator concept.
        `c2` - Implicated concept.
      Returns:
        A new implication concept under Kleene-Dienes semantics.

    - #### gImplies

          public static Concept gImplies(Concept c1,
                                         Concept c2)

      Gets a new implication concept under Goedel semantics.
      Parameters:
        `c1` - Implicator concept.
        `c2` - Implicated concept.
      Returns:
        A new implication concept under Goedel semantics.

    - #### zImplies

          public static Concept zImplies(Concept c1,
                                         Concept c2)

      Gets a new implication concept under Zadeh semantics.
      Parameters:
        `c1` - Implicator concept.
        `c2` - Implicated concept.
      Returns:
        A new implication concept under Zadeh semantics.

    - #### some

          public static Concept some(java.lang.String role,
                                     Concept c)

      Gets a new existential restriction concept.
      Parameters:
        `role` - Abstract role.
        `c` - Concept.
      Returns:
        A new existential restriction concept.

    - #### hasValue

          public static Concept hasValue(java.lang.String role,
                                         Individual i)

      Gets a new has value restriction concept.
      Parameters:
        `role` - Abstract role.
        `i` - Individual.
      Returns:
        A new as value restriction concept.

    - #### hasValue

          public static Concept hasValue(java.lang.String role,
                                         java.lang.String i)

      Gets a new has value restriction concept.
      Parameters:
        `role` - Abstract role.
        `i` - Individual name.
      Returns:
        A new has value restriction concept.

    - #### notHasValue

          public static Concept notHasValue(java.lang.String role,
                                            java.lang.String i)

      Gets a new negated has value restriction concept.
      Parameters:
        `role` - Abstract role.
        `i` - Individual name.
      Returns:
        A new negated has value restriction concept.

    - #### all

          public static Concept all(java.lang.String role,
                                    Concept c)

      Gets a new universal restriction concept.
      Parameters:
        `role` - Abstract role.
        `c` - Concept.
      Returns:
        A new universal restriction concept.

    - #### self

          public static Concept self(java.lang.String role)

      Gets a new local reflexivity concept.
      Parameters:
        `role` - Abstract role.
      Returns:
        A new local reflexivity concept.

    - #### upperApprox

          public static Concept upperApprox(java.lang.String role,
                                            Concept c)

      Gets a new upper fuzzy rough concept.
      Parameters:
        `role` - Abstract role.
        `c` - Concept.
      Returns:
        A new pper fuzzy rough concept.

    - #### lowerApprox

          public static Concept lowerApprox(java.lang.String role,
                                            Concept c)

      Gets a new lower fuzzy rough concept.
      Parameters:
        `role` - Abstract role.
        `c` - Concept.
      Returns:
        A new lower fuzzy rough concept.

    - #### tightUpperApprox

          public static Concept tightUpperApprox(java.lang.String role,
                                                 Concept c)

      Gets a new tight upper fuzzy rough concept.
      Parameters:
        `role` - Abstract role.
        `c` - Concept.
      Returns:
        A new tight upper fuzzy rough concept.

    - #### tightLowerApprox

          public static Concept tightLowerApprox(java.lang.String role,
                                                 Concept c)

      Gets a new tight lower fuzzy rough concept.
      Parameters:
        `role` - Abstract role.
        `c` - Concept.
      Returns:
        A new tight lower fuzzy rough concept.

    - #### looseUpperApprox

          public static Concept looseUpperApprox(java.lang.String role,
                                                 Concept c)

      Gets a new loose upper fuzzy rough concept.
      Parameters:
        `role` - Abstract role.
        `c` - Concept.
      Returns:
        A new loose upper fuzzy rough concept.

    - #### looseLowerApprox

          public static Concept looseLowerApprox(java.lang.String role,
                                                 Concept c)

      Gets a new loose lower fuzzy rough concept.
      Parameters:
        `role` - Abstract role.
        `c` - Concept.
      Returns:
        A new loose lower fuzzy rough concept.

    - #### atMostValue

          public static Concept atMostValue(java.lang.String role,
                                            java.lang.Object o)

      Gets a new at-most datatype restriction concept.
      Parameters:
        `role` - Concrete feature.
        `o` - Value of the concrete filler.
      Returns:
        A new at-most datatype restriction concept.

    - #### atLeastValue

          public static Concept atLeastValue(java.lang.String role,
                                             java.lang.Object o)

      Gets a new at-least datatype restriction concept.
      Parameters:
        `role` - Concrete feature.
        `o` - Value of the concrete filler.
      Returns:
        A new at-least datatype restriction concept.

    - #### exactValue

          public static Concept exactValue(java.lang.String role,
                                           java.lang.Object o)

      Gets a new exact datatype restriction concept.
      Parameters:
        `role` - Concrete feature.
        `o` - Value of the concrete filler.
      Returns:
        A new exact datatype restriction concept.

    - #### weightedConcept

          public static Concept weightedConcept(double w,
                                                Concept c)

      Gets a new weighted concept.
      Parameters:
        `w` - Weight.
        `c` - Concept.
      Returns:
        A new weighted concept.

    - #### posThreshold

          public static Concept posThreshold(double w,
                                             Concept c)

      Gets a new positive threshold concept.
      Parameters:
        `w` - Weight.
        `c` - Concept.
      Returns:
        A new positive threshold concept.

    - #### negThreshold

          public static Concept negThreshold(double w,
                                             Concept c)

      Gets a new negative threshold concept.
      Parameters:
        `w` - Weight.
        `c` - Concept.
      Returns:
        A new negative threshold concept.

    - #### extendedPosThreshold

          public static Concept extendedPosThreshold(Variable w,
                                                     Concept c)

      Gets a new extended positive threshold concept.
      Parameters:
        `w` - Variable.
        `c` - Concept.
      Returns:
        A new extended positive threshold concept.

    - #### extendedNegThreshold

          public static Concept extendedNegThreshold(Variable w,
                                                     Concept c)

      Gets a new extended negative threshold concept.
      Parameters:
        `w` - Variable.
        `c` - Concept.
      Returns:
        A new extended negative threshold concept.

    - #### complement

          public static Concept complement(Concept c)

      Gets the complement of the concept.
      Parameters:
        `c` - A concept to be complemented.
      Returns:
        Complement of the concept.

    - #### toString

          public java.lang.String toString()

      Gets a printable name of the concept.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        Name of the concept.

    - #### setName

          public void setName(java.lang.String newName)

      Sets the name of the concept.
      Parameters:
        `newName` - Name of the concept.

    - #### getType

          public int getType()

      Gets the type of the concept.
      Returns:
        Type of the concept.

    - #### getRole

          public java.lang.String getRole()

      Gets the role attribute.
      Returns:
        Role.

    - #### getValue

          public java.lang.Object getValue()

      Gets the value attribute.
      Returns:
        Value.

    - #### setValue

          public void setValue(java.lang.Object newValue)

      Sets the value attribute.
      Parameters:
        `newValue` - Value.

    - #### setType

          public void setType(int type)

      Sets the type of the concept.
      Parameters:
        `type` - Type of the concept.

    - #### getWeight

          public double getWeight()

      Gets the weight attribute.
      Returns:
        Weight.

    - #### getWeightVar

          public Variable getWeightVar()

      Gets the weight variable;
      Returns:
        Weight variable.

    - #### isConcrete

          public boolean isConcrete()

      Checks if the concept is concrete (types CONCRETE, CONCRETE_COMPLEMENT, FUZZY_NUMBER or FUZZY_NUMBER_COMPLEMENT)
      Returns:
        true if the concepts is concrete; false otherwise.

    - #### isAtomic

          public boolean isAtomic()

      Checks if the concept is atomic.
      Returns:
        true if the concepts is atomic; false otherwise.

    - #### isComplementedAtomic

          public boolean isComplementedAtomic()

      Checks if the concept is complemented atomic.
      Returns:
        true if the concepts is atomic; false otherwise.

    - #### containsNegatedSubconcept

          public static int containsNegatedSubconcept(java.util.ArrayList<Concept> v,
                                                      Concept cj)

    - #### containsSubconcept

          public static boolean containsSubconcept(java.util.ArrayList<Concept> v,
                                                   Concept cj)

    - #### removeElement

          public static void removeElement(java.util.ArrayList<Concept> v,
                                           int i)

    - #### replace

          public Concept replace(Concept a,
                                 Concept c)
                          throws FuzzyOntologyException

      Gets a new concept by replacing an atomic concept a with a complex concept c.
      Parameters:
        `a` - Atomic concept.
        `c` - Complex concept.
      Returns:
        Complement of the concept.
      Throws:
        `FuzzyOntologyException` - Parsing error.

    - #### getAtomicConcepts

          public java.util.HashSet<Concept> getAtomicConcepts()

    - #### getAtomicConceptNames

          public java.util.HashSet<java.lang.String> getAtomicConceptNames()

    - #### equals

          public boolean equals(Concept c)

    - #### hasNominals

          public boolean hasNominals()